<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Name Table Entry</TITLE>
<link href="suifmath_17.html" rel=Next>
<link href="suifmath_15.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_15.html">previous</A>, <A HREF="suifmath_17.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC16" HREF="suifmath_toc.html#TOC16">Name Table Entry</A></H2>
<P>
<A NAME="IDX332"></A>

</P>
<P>
A <CODE>name_table_entry</CODE> represents an individual name.
Each name has a SUIF variable or a string as the name and an
associated <CODE>name_table_entry_kind</CODE>.  

</P>
<P>
The <CODE>name_table_entry_kind</CODE> describes the properties of the name.
Valid kinds are:
<A NAME="IDX333"></A>
<DL COMPACT>

<DT>nte_none
<DD>
No kind was assigned.
<A NAME="IDX334"></A>
<A NAME="IDX335"></A>

<DT>nte_symconst
<DD>
The name represents a symbolic constant.
<A NAME="IDX336"></A>
<A NAME="IDX337"></A>
                            
<DT>nte_cond
<DD>
The name represents a conditional variable.
<A NAME="IDX338"></A>
<A NAME="IDX339"></A>
                             
<DT>nte_loop
<DD>
The name represents a loop index variable.
<A NAME="IDX340"></A>
<A NAME="IDX341"></A>
                             
<DT>nte_dim
<DD>
The name represents an array dimension.
<A NAME="IDX342"></A>
<A NAME="IDX343"></A>
                             
<DT>nte_summary
<DD>
The name represents a loop index or a conditional that has been
projected away.
<A NAME="IDX344"></A>
<A NAME="IDX345"></A>
                             
<DT>nte_aux
<DD>
An auxiliary variable.  For auxiliary variables, there is no SUIF
variable or string attached to it. Between systems of inequalities, no
two auxiliary variables are equal, and thus do not require a name to
identify them.
<A NAME="IDX346"></A>
<A NAME="IDX347"></A>

</DL>

<P>
Even though two different names are of different kinds, they can match
up if the names match.  For example, name table entries <CODE>NA</CODE> and
<CODE>NB</CODE> both have SUIF variable <CODE>v</CODE> as the name. But
<CODE>NA</CODE> is a symbolic constant and <CODE>NB</CODE> is a loop index variable.
When aligning, <CODE>NA</CODE> and <CODE>NB</CODE> will match up and the resulting
name will be of loop index kind.

</P>

<P>
The following are functions and operations available on
<CODE>name_table_entry</CODE>.  
In this list of functions, 
symbols <CODE>nte</CODE>, <CODE>nte1</CODE> and
<CODE>nte2</CODE>  are of the class <CODE>name_table_entry</CODE>, 
symbol <CODE>knd</CODE> is a <CODE>name_table_entry_kind</CODE> and
<CODE>im</CODE> is of the class <CODE>immed</CODE>.
<DL COMPACT>

<DT><CODE>name_table_entry nte();</CODE>
<DD>
<DT><CODE>nte.init();</CODE>
<DD>
Initialize <CODE>nte</CODE> as a null entry.
<A NAME="IDX348"></A>
<A NAME="IDX349"></A>

<DT><CODE>name_table_entry nte(im);</CODE>
<DD>
<DT><CODE>nte.init(im);</CODE>
<DD>
Initialize <CODE>nte</CODE> using <CODE>im</CODE>. If <CODE>im</CODE> is a variable name
(class <CODE>var_sym</CODE>) or character string, the kind will be a symbolic
constant; otherwise no name is set and <CODE>nte</CODE> will be an auxiliary
variable.
<A NAME="IDX350"></A>
<A NAME="IDX351"></A>

<DT><CODE>name_table_entry nte(knd, im);</CODE>
<DD>
<DT><CODE>nte.init(knd, im);</CODE>
<DD>
The name is extracted from <CODE>im</CODE> and the kind is set to <CODE>knd</CODE>.
If <CODE>knd</CODE> is of auxiliary variable type, <CODE>im</CODE> is disregarded.
<A NAME="IDX352"></A>
<A NAME="IDX353"></A>

<DT><CODE>name_table_entry nte(nte1);</CODE>
<DD>
<DT><CODE>nte.init(nte1);</CODE>
<DD>
A copy of <CODE>nte1</CODE> is made.
<A NAME="IDX354"></A>
<A NAME="IDX355"></A>

<DT><CODE>im = nte.name();</CODE>
<DD>
<DT><CODE>char * str = nte.string();</CODE>
<DD>
<DT><CODE>var_sym * vs = nte.var();</CODE>
<DD>
Get the name of the entry.  While <CODE>name()</CODE> and <CODE>string()</CODE> will
work for both character strings and SUIF variable symbols,
<CODE>var()</CODE> can be used only on entries with SUIF variable symbol
names. If the name table entry is of auxiliary variable kind, none of
the above functions are applicable.
<A NAME="IDX356"></A>
<A NAME="IDX357"></A>
<A NAME="IDX358"></A>

<DT><CODE>nte.set_name(im);</CODE>
<DD>
Set the name of the entry. 
<A NAME="IDX359"></A>

<DT><CODE>knd = nte.kind();</CODE>
<DD>
Get the name table entry kind.
<A NAME="IDX360"></A>

<DT><CODE>nte.mark_sym();</CODE>
<DD>
<DT><CODE>nte.mark_cond();</CODE>
<DD>
<DT><CODE>nte.mark_loop();</CODE>
<DD>
<DT><CODE>nte.mark_dim();</CODE>
<DD>
<DT><CODE>nte.mark_summary();</CODE>
<DD>
<DT><CODE>nte.mark_aux();</CODE>
<DD>
Change the name table entry kind.  If the kind is set to auxiliary
variable, the name will be deleted.
<A NAME="IDX361"></A>
<A NAME="IDX362"></A>
<A NAME="IDX363"></A>
<A NAME="IDX364"></A>
<A NAME="IDX365"></A>
<A NAME="IDX366"></A>

<DT><CODE>nte1 == nte2</CODE>
<DD>
<DT><CODE>nte1 != nte2</CODE>
<DD>
Check if two entries are identical (both the name and the kind).
<A NAME="IDX367"></A>
<A NAME="IDX368"></A>

<DT><CODE>FILE * fp;</CODE>
<DD>
<DT><CODE>nte.print(fp);</CODE>
<DD>
Print the name table entry.
<A NAME="IDX369"></A>

</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_15.html">previous</A>, <A HREF="suifmath_17.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
